package com.GreenDAO.relacion1_N;

import de.greenrobot.daogenerator.DaoGenerator;
import de.greenrobot.daogenerator.Entity;
import de.greenrobot.daogenerator.Schema;
import de.greenrobot.daogenerator.ToMany;

//Ejemplo creacin de objetos DAO, a partir de entidades con relacin de 1 a varios(API GreenDAO)
//
//academiaandroid.com
//
//by Jos Antonio Gzquez Rodrguez

public class Entidades {

	
	public static void main(String[] args) 
	{
		try
		{
			Schema schema = new Schema(1,"com.GreenDAO.relacion1_N");
	        relacionesEntidad(schema);
	        new DaoGenerator().generateAll(schema,"../Relaciones_ORM_GreenDAO/src"); 
		}catch(Exception ex)
		{
			System.out.println (ex.getMessage());
		}
	}
	
	public static void relacionesEntidad(Schema schema)
	{
		try{
			
			//Aadimos la tabla Profesores al Esquema o BD
	        Entity profesores = schema.addEntity("Profesores");
	        //Creamos un campo ID de tipo autonumrico
	        profesores.addIdProperty();
	        //Se aaden los campos Nombre, Apellidos y Curso, que no admitirn valores nulos
	        profesores.addStringProperty("Nombre").notNull();
	        profesores.addStringProperty("Apellidos").notNull();
	        profesores.addStringProperty("Curso").notNull();
	        
	        //Aadimos la Tabla Asignaturas al Esquema o BD
	        Entity asignaturas = schema.addEntity("Asignaturas");
	        //Creamos un campo ID de tipo autonumrico
	        asignaturas.addIdProperty();
	        //Se aaden los campos Historia, Matemticas y Lenguaje, que no admitirn valores nulos
	        asignaturas.addBooleanProperty("Historia").notNull();
	        asignaturas.addBooleanProperty("Matemticas").notNull();
	        asignaturas.addBooleanProperty("Lenguaje").notNull();
			
	        //Campo que ser clave fornea de la tabla Profesores en la Tabla Asignaturas
	        de.greenrobot.daogenerator.Property idProfesor = asignaturas.addLongProperty("idProfesor").getProperty(); 
	        
	        //Se establece la relacin 1 a varios. Profesores(1) -> Asignaturas(N)
	        ToMany asignaturasAlumno = profesores.addToMany(asignaturas, idProfesor);
	        asignaturasAlumno.setName("asignaturas");
	        
	        asignaturas.addToOne(profesores, idProfesor);
			
		}catch(Exception ex)
		{
			System.out.println("Error al crear entidades o establecer relaciones: " + ex.getMessage());
		}	
	}
}
